/************************************************************************** 
ļ: dm_tft_ppiinit.c
: Andy
汾: 0.1 
ʱ : 2007-04 
: 
	ļʵBF533PPIȺĳʼ
޸ʷ: 
****************************************************************************/ 
#include "dm_bf5xx.h"
#include "dm_types.h"

/****************************************************************************
*   ⲿı
****************************************************************************/

extern uint8_t DisplayBuffer[262][960];
/****************************************************************************
*   Init_PPI
*   PPI ʼ
* ڲ 
* ڲ 
****************************************************************************/
static void Init_TFTPPI(void)
{	
	*pPPI_DELAY = 100;		
	*pPPI_COUNT = 959;		//960 samples per line
}
/****************************************************************************
*   Init_PPIDMA
*   PPIDMA ʼ
* ڲ 
* ڲ 
****************************************************************************/
void Init_PPIDMA(uint8_t *start)
{
	*pDMA0_START_ADDR =(int_t)start;
	*pDMA0_X_COUNT = 960/2;
	*pDMA0_X_MODIFY = 2;
	*pDMA0_Y_COUNT = 262;
	*pDMA0_Y_MODIFY = 2;
	*pDMA0_CONFIG = 0x1034;
}
/****************************************************************************
*   Init_Timer
*   ʼʱΪPWM ģʽ  TMR1  TMR2 
* ڲ 
* ڲ 
****************************************************************************/
static void Init_Timer(void)
{
	*pTIMER1_PERIOD		= 1224;
	*pTIMER1_WIDTH		= 88;
	*pTIMER1_CONFIG		= 0x00a9;
	*pTIMER2_PERIOD		= 320688;
	*pTIMER2_WIDTH		= 3672;
	*pTIMER2_CONFIG		= 0x00a9;
}
/****************************************************************************
*   Init_TFTCPLD
*    CPLDPPIʱлTFTģ
* ڲ 
* ڲ 
****************************************************************************/
static void Init_TFTCPLD(void)  
{
	*pCtrOut_Flag_OE = ~TFT_245_OE ; //CMOS_OE 245  ADG_OE=1
	mdelay(500);
    *pCtrOut_Flag_B  = ~TFTCLK_SET;
    mdelay(500);
}
/****************************************************************************
*   PPI_TMR_DMA_Enable
*    PPI  DMA  TMR   
* ڲ 
* ڲ 
****************************************************************************/
 void PPI_TMR_DMA_Enable(void)
{
	*pDMA0_CONFIG |= 0x1;
	asm("ssync;");
	*pPPI_CONTROL =  0x809f;
	Init_Timer();			
	*pPPI_CONTROL |= 0x1; 		//ʹPPI
	asm("ssync;");
	*pTIMER_ENABLE= 0x0006;
	asm("ssync;");
}
/****************************************************************************
*   Init_Platform_TFT
*   ʼTFT
* ڲ 
* ڲ 
****************************************************************************/
void Init_Platform_TFT(void)
{
    Init_TFTCPLD();
	Init_TFTPPI();
	PPI_TMR_DMA_Enable();
}
/****************************************************************************
*   PPI_TMR_DMAR_Disable
*   رPPIDMA
* ڲ 
* ڲ 
****************************************************************************/
void PPI_TMR_DMAR_Disable(void)
{
	*pDMA0_CONFIG &= (~DMA_EN);
	*pPPI_CONTROL &= (~PORT_EN);
}
